#!/bin/bash 
#-e
# 62.68.193.91
# mediaupdate.loxone.com
UPDATES_DIR="/home/updates"
UPDATES_RECOVERY="http://mediaupdate.loxone.com/recovery/${1}.tgz"
UPDATES_RECOVERY_SIGN="http://mediaupdate.loxone.com/recovery/${1}.tgz.sha1"
SIGNPUB=/usr/share/loxoneWS/updater/sign.pub
LOCAL_RECOVERY="$(basename ${UPDATES_RECOVERY})"

mkdir -p "$UPDATES_DIR"

if [ "$#" -ne 1 ] ; then
	echo "X missing Recovery ID or too many extra parameters"
	exit 0
fi

if [[ ! -d "${UPDATES_DIR}/recovery" ]] ; then
    mkdir "${UPDATES_DIR}/recovery"
else
    rm -rf "${UPDATES_DIR}/recovery/*"
fi
if ! wget --quiet -c --tries=10 --timeout=15 "${UPDATES_RECOVERY}" -O "${UPDATES_DIR}/recovery/${LOCAL_RECOVERY}" ;then
	echo "X Failed to download recovery binary file, check Recovery ID"
	exit 1
fi
echo "+ Got Recovery file, downloading signature file"

if ! wget --quiet -c --tries=10 --timeout=15 "${UPDATES_RECOVERY_SIGN}" -O "${UPDATES_DIR}/recovery/${LOCAL_RECOVERY}.sha1" ;then
	echo "X Failed to download recovery signature file, please try again"
	exit 1
fi
echo "+ Got Signature file, verify signature"
VERIFY=`openssl dgst -verify "${SIGNPUB}" -signature "${UPDATES_DIR}/recovery/${LOCAL_RECOVERY}.sha1" "${UPDATES_DIR}/recovery/${LOCAL_RECOVERY}"`
if [[ ${VERIFY} == "Verified OK" ]] ; then
    echo "+ Signature verification successful, unpacking and installing"
    tar -xzf "${UPDATES_DIR}/recovery/${LOCAL_RECOVERY}" --directory "${UPDATES_DIR}/recovery/"
    cd ${UPDATES_DIR}/recovery/${1}
    /bin/bash recover.sh
else 
    echo "X Failed to verify recovery file, possible corruption while download. Try again"
    exit 1
fi
rm -rf ${UPDATES_DIR}/recovery/*
exit 0
