<?php

/* Music Provider Authorization Helper 
 * (C) 2016 Loxone Electronics - michael.schoenwiese@loxone.com
 * Request Usage: http://<ip of musicserver>/<servicename>/<uuid of user>
 * servicename is one of: spotify, ... 
 * uuid of user is needed to distinguish between different accounts within a family, ie spotify family accounts
 * See .htaccess for redirects 
 *  
 */

ini_set('error_reporting', E_WARNING | E_ERROR);
ini_set('display_errors', 1);

$provider = filter_input(INPUT_GET, 'provider', FILTER_SANITIZE_STRING);

/* Spotify - Initialize Helper Classes */
if ($provider == "spotify") {
    require 'spotify/_autoload.php';
    $session = new SpotifyWebAPI\Session(
            'fdbd030ce73b4abdb08fc05760805dbf', 'ab9935304379490485af109158d3caca', 'http://mediaupdate.loxone.com/preflight/spotify.php'
    );
    $api = new SpotifyWebAPI\SpotifyWebAPI();
}

/* Redirect BACK from mediaupdate Server */
if (isset($_REQUEST['data'])) {
    $redirectData = json_decode(base64_decode($_REQUEST['data']));
    $session->requestAccessToken($redirectData->code);
    $postdata = array(
                'accessToken' => $session->getAccessToken(),
                'refreshToken' => $session->getRefreshToken(),
                'tokenExpiration' => $session->getTokenExpiration(),
                'random' => $redirectData->redirect_id
    );
    $opts = array(
        'http' => array(
            'method' => 'POST',
            'header' => 'Content-Type: application/json',
            'content' => json_encode($postdata)
        )
    );
    $context = stream_context_create($opts);
    echo file_get_contents("http://localhost:7071/cfg:user:settoken", false, $context);
    
    exit();
}
/* Request Section - Redirect TO Auth Provider */ else {
    $userid = filter_input(INPUT_GET, 'uuid', FILTER_SANITIZE_STRING);
    $spuser = filter_input(INPUT_GET, 'user', FILTER_SANITIZE_STRING);
    $random = filter_input(INPUT_GET, 'rnd', FILTER_SANITIZE_STRING);

    if ($provider == "spotify") {
        $options = array(
            'scope' => array(
                'user-read-email',
                'user-library-modify',
                'playlist-modify-private',
                'playlist-modify-public',
                'user-read-private',
                'user-follow-modify'
            ),
            'state' => base64_encode(json_encode(array('redirect_id' => $random, 'redirect_ip' => $_SERVER['SERVER_ADDR'], 'provider' => $provider))),
        );
        header('Location: ' . $session->getAuthorizeUrl($options));
    }
}
