<?php
// execution array
$bin = 'sudo /usr/share/loxoneWS/bin/reconfig';
define(_LOXONECONF, "/etc/loxone.conf");
define(_UPDATEMSGS, "/tmp/LoxoneUpdater");

session_start();

if (isset($_REQUEST['updatelevel'])) {
    $level = filter_input(INPUT_GET, 'updatelevel', FILTER_SANITIZE_STRING);

    if (($level == "test") || ($level == "intern")) {
        shell_exec($bin . " autoupdate intern");
    } else if ($level == "beta") {
        shell_exec($bin . " autoupdate beta");
    } else {
        $level = "release";
        shell_exec($bin . " autoupdate release");
    }
    $_SESSION['notifyUpdateLevelChange'] = $level;
    Header("Location: /");
    exit();
}

if (isset($_REQUEST['force-reinstall'])) {
    shell_exec("sudo /usr/share/loxoneWS/updater/FORCE_UPDATER.sh > /dev/null 2>&1 &");
    $_SESSION['notifyForceUpdate'] = "true";
    Header("Location: /");
    exit();
}

if (isset($_REQUEST['force-langinstall'])) {
    shell_exec("sudo /usr/share/loxoneWS/bin/reconfig autoupdate lang > /dev/null 2>&1 &");
    Header("Location: /");
    exit();
}

if (isset($_REQUEST['action'])) {
    switch ($_REQUEST['action']) {
        case "resetdhcp":
            $hostname = filter_input(INPUT_GET, 'hostname', FILTER_SANITIZE_STRING);
            echo "{ \"action\": \"resetdhcp\", \"hostname\": \"" . $hostname . "\"}";
            shell_exec($bin . " write " . $var . " dhcp DONTTZME");
            break;
        case "savesettings":
            $hostname = filter_input(INPUT_GET, 'hostname', FILTER_SANITIZE_STRING);
            $ip = filter_input(INPUT_GET, ip, FILTER_SANITIZE_STRING);
            $subnet = filter_input(INPUT_GET, 'subnet', FILTER_SANITIZE_STRING);
            $gateway = filter_input(INPUT_GET, 'gateway', FILTER_SANITIZE_STRING);
            $dns = filter_input(INPUT_GET, 'dns', FILTER_SANITIZE_STRING);
            echo "{ \"action\": \"resetdhcp\", \"hostname\": \"" . $hostname . "\","
            . "\"ip\": \"" . $ip . "\","
            . "\"subnet\": \"" . $subnet . "\","
            . "\"gateway\": \"" . $gateway . "\","
            . "\"dns\": \"" . $dns . "\"}";
            shell_exec($bin . " write " . $hostname . " " . $ip . " " . $subnet . " " . $gateway . " " . $dns . " DONTTZME");
            break;
        case "restartservices":
            echo "{ \"action\": \"restartservices\"}";
            shell_exec($bin);
            break;
        case "restartserver":
            echo "{ \"action\": \"restartserver\"}";
            shell_exec($bin . " reboot");
            break;
        case "getConfig":
            echo json_encode(loadLoxoneConf());
            break;
        case "setAutoUpdate":
            $bAutoUpdate = filter_input(INPUT_GET, 'autoupdate', FILTER_SANITIZE_STRING);
            if ($bAutoUpdate == "true") {
                shell_exec("sudo /usr/share/loxoneWS/bin/reconfig autoupdate 120");
            } else {
                shell_exec("sudo /usr/share/loxoneWS/bin/reconfig autoupdate 0");
            }
            echo json_encode(array('autoupdate' => $bAutoUpdate));
            break;
        case "doUpdate":
            shell_exec("sudo /usr/share/loxoneWS/bin/reconfig autoupdate start > /dev/null 2>&1 &");
            echo json_encode(array('doUpdate' => true));
            break;
        case "getUpdateStatus":
            $updatemessages = preg_split("/\n/", file_get_contents(_UPDATEMSGS));
            foreach ($updatemessages as $line => $entry) {
                $stageEntry = preg_split("/:/", $entry);
                $arrEntries[$line] = $stageEntry;
                if ($stageEntry[2] != "") {
                    list ($stage, $error, $flag) = $stageEntry;
                }
            }
            echo json_encode(array("stage" => $stage, "error" => $error, "flag" => $flag, "data" => $arrEntries));
            break;
    }
    exit();
}

/* Load /etc/loxone.conf */

function loadLoxoneConf() {
    $file = fopen(_LOXONECONF, 'r');
    $conf = array();
    while (!feof($file)) {
        $line = preg_split("/=/", fgets($file), -1, PREG_SPLIT_NO_EMPTY);
        if ($line[1])
            $conf[strtolower($line[0])] = preg_replace("/\n$/", "", $line[1]);
    }
    return $conf;
}

/* Load Statistics from /var/run/loxone */

function loadStatsFile($fileName) {
    $cpustats = new stdClass;
    foreach (preg_split("/\t/", preg_replace("/\n$/", "", file_get_contents($fileName))) as $idx => $statsitem) {
        if ($idx == 0)
            $timestamp = $statsitem;
        else if (strlen($statsitem) > 0) {

            $item = preg_split("/:/", $statsitem);
            $cpustats->$item[0] = $item[1];
        } else
            return -1;
    }
    return $cpustats;
}

/* Nice Uptime Formatter */

function niceUptime($uptime) {
    $days = explode(".", (($uptime % 31556926) / 86400));
    $hours = explode(".", ((($uptime % 31556926) % 86400) / 3600));
    $minutes = explode(".", (((($uptime % 31556926) % 86400) % 3600) / 60));
    $time = ".";
    $time = $minutes[0] . " #mins#" . $time;
    if ($minutes > 0 && ($hours[0] > 0 || $days[0] > 0)) {
        $time = ", " . $time;
    }
    if ($hours[0] > 0) {
        $time = $hours[0] . " #hours#" . $time;
    } 
    if ($hours[0] > 0 && $days[0] > 0) {
        $time = ", " . $time;
    } 
    if ($days[0] > 0) {
        $time = $days[0] . " #days#" . $time;
    } 
    return array("days" => intval($days[0]), "minutes" => intval($minutes[0]), "hours" => intval($hours[0]));
}

// get server details
$json = shell_exec('sudo /usr/share/loxoneWS/bin/reconfig read');
$input = json_decode($json);
$version = $input->server_net_config[0]->version;
$ver = preg_split("/\./", $version); // Fix Version String
$version = intval($ver[0]) . "." . intval($ver[1]) . "." . intval($ver[2]) . "." . intval($ver[3]);
$name = $input->server_net_config[0]->Servername;
$ip = $input->server_net_config[0]->ip;
$mask = $input->server_net_config[0]->mask;
$gateway = $input->server_net_config[0]->gateway;
$dns = $input->server_net_config[0]->dns;
$timezone = $input->server_net_config[0]->timezone;
$networkmode = $input->server_net_config[0]->networkmode;
$lastconfig = $input->server_net_config[0]->lastconfig;
$master = $input->server_net_config[0]->master;
$loxoneConf = loadLoxoneConf();
$updatelevel = $loxoneConf['updatelevel'];
if (($updatelevel == "beta") || ($updatelevel == "intern"))
    $updatelevelText = " (" . strtoupper($updatelevel) . ")";
else
    $updatelevelText = "";
if (isset($_SESSION['notifyUpdateLevelChange'])) {
    $newUpdateLevel = $_SESSION['notifyUpdateLevelChange'];
    unset($_SESSION['notifyUpdateLevelChange']);
} else {
    $newUpdateLevel = "0";
}

if (isset($_SESSION['notifyForceUpdate'])) {
    $forceUpdate = "1";
    unset($_SESSION['notifyForceUpdate']);
} else {
    $forceUpdate = "0";
}
?>

<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="description" content="Loxone Musicserver">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Loxone Music Server</title>
        <link rel="stylesheet" href="css/bootstrap.min.css">
        <link rel="stylesheet" href="css/main.css">
        <link rel="stylesheet" href="css/bootstrap.mod.css">
        <link rel="stylesheet" href="css/font-awesome.min.css">
    </head>
    <body>
        <div class="header-wrapper nav">
            <div class="header" id="versiontag">
                <h1>Loxone Music Server</h1>
                <p>Version <?php echo $version . $updatelevelText ?></p>
            </div>
        </div>
        <ul class="nav nav-tabs" role="tablist">
            <li role="presentation" class="active" id="tab-status"><a href="#panel-status" aria-controls="status" role="tab" data-toggle="tab"></a></li>
            <li role="presentation" id="tab-settings"><a href="#panel-settings" aria-controls="settings" role="tab" data-toggle="tab"></a></li>
            <li role="presentation" id="tab-actions"><a href="#panel-actions" aria-controls="settings" role="tab" data-toggle="tab"></a></li>
        </ul>
        <div class="container" id="content">
            <div class="tab-content">

                <div role="tabpanel" class="tab-pane active settings" id="panel-status" <?php if (($_SERVER['REMOTE_ADDR'] == "127.0.0.1") || ($_SERVER['REMOTE_ADDR'] == $_SERVER['SERVER_ADDR'])) echo "data-disabled"; ?>>
                    <div class="row">
                        <div class="col-xs-12 col-md-6 col-lg-6">
                            <div class="panel panel-default" id="systemState">
                                <div class="panel-heading" data-toggle="collapse" data-target="#systemStateDetail">
                                    <div class="panel-title"></div>
                                </div>
                                <div id="systemStateDetail" class="collapse in">
                                    <table class="table table-condensed table-striped">
                                        <tr id="health-uptime"><td></td><td class="text-right" id="systemStateDetail-Uptime"></td></tr>
                                        <tr id="health-cpu"><td></td><td class="text-right" id="systemStateDetail-CPULoad"></td></tr>
                                        <tr id="health-disk"><td></td><td class="text-right" id="systemStateDetail-DISKLoad"></td></tr>
                                        <tr id="health-logitech"><td></td><td class="text-right" id="systemStateDetail-Logitech"></td></tr>
                                        <tr id="health-lms"><td></td><td class="text-right" id="systemStateDetail-LMS"></td></tr>
                                        <tr id="health-masterms"><td></td><td class="text-right"><?php echo $master . "<br>(" . $lastconfig . ")"; ?></td></tr>
                                    </table>
                                </div>
                            </div>
                        </div>
                        <div class="col-xs-12 col-md-6 col-lg-6">
                            <div class="panel panel-default" id="networkState">
                                <div class="panel-heading" data-toggle="collapse" data-target="#networkStateDetail">
                                    <div class="panel-title"><span class="glyphicon pull-right" /></div>
                                </div>
                                <div id="networkStateDetail" class="collapse in">
                                    <table class="table table-condensed table-striped">
                                        <tr id="health-nw-gw"><td></td><td class="text-right" id="networkStateDetail-LPing" data-toggle="tooltip" data-placement="bottom" title=""></td></tr>
                                        <tr id="health-nw-ms"><td></td><td class="text-right" id="networkStateDetail-MSPing" data-toggle="tooltip" data-placement="bottom" title=""></td></tr>
                                        <tr id="health-nw-inet"><td></td><td class="text-right" id="networkStateDetail-RPing" data-toggle="tooltip" data-placement="bottom" title=""></td></tr>
                                    </table>
                                </div>

                            </div>
                        </div>
                        <div class="col-xs-12 col-md-6 col-lg-6"> 
                            <div class="panel panel-default" id="zoneState">
                                <div class="panel-heading" data-toggle="collapse" data-target="#zoneStateDetail">
                                    <div class="panel-title"></div>
                                </div>
                                <div id="zoneStateDetail" class="collapse in"> 
                                    <table class="table table-condensed table-striped" id="zones">

                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div role="tabpanel" class="tab-pane settings" id="panel-settings">
                    <div class="row">
                        <div class="col-xs-12 col-md-6">
                            <div class="panel panel-success" id="autoupdates">
                                <div class="panel-heading">
                                    <div class="panel-title"><span class="glyphicon pull-right" /></div>
                                </div>
                                <div class="panel-body" data-state="expanded">
                                    <input type="checkbox" name="autoupd" id="autoupdate-schedule"><h5 style="display:inline; margin-left: 5px;"></h5>
                                    <?php
                                    if (($updatelevel == "beta") || ($updatelevel == "intern")) {
                                        $link = "<a href=\"http://" . $_SERVER['SERVER_ADDR'] . "/release\">http://" . $_SERVER['SERVER_ADDR'] . "/release</a>";
                                        echo "<p id=\"updatelevel-revert\"></p>" . $link;
                                    }
                                    ?>
                                </div>
                            </div>
                        </div>
                        <div class="col-xs-12 col-md-6">
                            <div class="col-xs-12 spacer"></div>
                            <div class="panel panel-success" id="networksettings">
                                <div class="panel-heading">
                                    <div class="panel-title"><span class="glyphicon glyphicon-triangle-bottom btn-xs pull-right alignCaret" ></span></div>
                                </div>
                                <div class="panel-body" data-state="collapsed">

                                </div>
                            </div>
                        </div>

                    </div>
                </div>
                <div role="tabpanel" class="tab-pane settings" id="panel-actions">
                    <div class="row">
                        <div class="col-xs-offset-0 col-xs-12 col-sm-offset-3 col-sm-6">
                            <div class="list-group">
                                <button type="button" class="btn btn-default btn-block btn-lg" id="btn-action-update"><span class="pull-left"></span><span class="glyphicon glyphicon-download-alt pull-right" /></button>
                                <button type="button" class="btn btn-default btn-block btn-lg" id="btn-action-restart"><span class="pull-left"></span><span class="glyphicon glyphicon-refresh pull-right" /></button>
                                <button type="button" class="btn btn-default btn-block btn-lg" id="btn-action-reboot"><span class="pull-left"></span><span class="glyphicon glyphicon-repeat pull-right" /></button>
                                <div class="col-xs-12 spacer"></div>
                                <button type="button" class="btn btn-default btn-block btn-lg" id="btn-action-docs"><span class="pull-left"></span><span class="glyphicon glyphicon-education pull-right" /></button>
                            </div>
                        </div>
                    </div>

                </div>
            </div>
        </div>
        <!-- Modal for Updatelevel Change Notification -->
        <div id="modalUpdLvlChg" class="modal fade" tabindex="-1" role="dialog" data-changedto="<?php echo $newUpdateLevel; ?>">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <h4 class="modal-title"></h4>
                    </div>
                    <div class="modal-body">
                        <p></p>
                    </div> 
                    <div class="modal-footer">
                        <button type="button" class="btn btn-default" data-dismiss="modal" id="btn-cancel"></button>
                    </div>
                </div>
            </div>
        </div>
        <!-- Modal for Update Dialog -->
        <div id="modalUpdate" class="modal fade" tabindex="-1" role="dialog" data-forceupdate="<?php echo $forceUpdate; ?>">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <h4 class="modal-title"></h4>
                    </div>
                    <div class="modal-body">
                        <p id="description-update"></p>
                        <p id="state-update"></p>
                    </div>
                    <div class="modal-footer">  
                        <div class="row">
                            <div class="col-xs-5">
                                <?php
                                if (($updatelevel == "beta") || ($updatelevel == "intern")) {
                                    echo "<p class=\"text-left\"><a href=\"http://mediaupdate.loxone.com/" . $updatelevel . "updates/changelog.txt\" target=\"_blank\" id=\"changelog\"></a></p>";
                                }
                                ?>
                            </div>
                            <div class="col-xs-7">
                                <button type="button" class="btn btn-default" data-dismiss="modal" id="btn-cancel"></button>
                                <button id="btn-update" type="button" class="btn btn-primary"></button>
                            </div>
                        </div>
                    </div>
                </div><!-- /.modal-content -->
            </div><!-- /.modal-dialog -->
        </div><!-- /.modal -->

        <!-- Modal for Restart Dialog -->
        <div id="modalServiceRestart" class="modal fade" tabindex="-1" role="dialog">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <h4 class="modal-title"></h4>
                    </div>
                    <div class="modal-body">
                        <p id="description-restart"></p>
                        <p id="state-restart"></p>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-default" data-dismiss="modal" id="btn-cancel"></button>
                        <button id="btn-restart" type="button" class="btn btn-primary"></button>
                    </div>
                </div><!-- /.modal-content -->
            </div><!-- /.modal-dialog -->
        </div><!-- /.modal -->

        <!-- Modal for Reboot Dialog -->
        <div id="modalServerReboot" class="modal fade" tabindex="-1" role="dialog">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <h4 class="modal-title"></h4>
                    </div>
                    <div class="modal-body">
                        <p id="description-reboot"></p>
                        <p id="state-reboot"></p>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-default" data-dismiss="modal" id="btn-cancel"></button>
                        <button id="btn-reboot" type="button" class="btn btn-primary"></button>

                    </div>
                </div><!-- /.modal-content -->
            </div><!-- /.modal-dialog -->
        </div><!-- /.modal -->

        <!-- Panel Content "Network Settings" -->
        <div id="networkSettingsDetails" class="collapse">
            <h5>IP Address assignment method</h5>
            <div class="form-group form-inline form-horizontal">
                <div class="radio radio-inline pull-left">
                    <label>
                        <input type="radio" name="mode" id="mode_static" style="margin-right: 2px;" <?php if ($networkmode == "fixed ip") echo "checked"; ?>>
                    </label>
                </div>
                <div class="radio radio-inline">
                    <label>
                        <input type="radio" name="mode" id="mode_dhcp" style="margin-right: 2px;" <?php if ($networkmode == "dhcp") echo "checked"; ?>>
                    </label>
                </div>
            </div>
            <div class="form-group validationenabled has-feedback" id="name">
                <h5></h5>
                <input type="text" class="form-control" name="name" id="name" maxlength="15" value="<?php echo $name ?>"/>
                <span class="glyphicon form-control-feedback" aria-hidden="true" id="name"></span>
            </div>
            <div class="form-group validationenabled has-feedback" id="ip">
                <h5></h5>
                <input type="text" class="form-control" name="ip" id="ip" value="<?php echo $ip ?>" />
                <span class="glyphicon form-control-feedback" aria-hidden="true" id="ip"></span>
            </div>
            <div class="form-group validationenabled has-feedback" id="subnet">
                <h5></h5>
                <input type="text" class="form-control" name="subnet" id="subnet" value="<?php echo $mask ?>" />
                <span class="glyphicon form-control-feedback" aria-hidden="true" id="subnet"></span>
            </div>
            <div class="form-group validationenabled has-feedback" id="gateway">
                <h5></h5>
                <input type="text" class="form-control" name="gateway" id="gateway" value="<?php echo $gateway ?>" />
                <span class="glyphicon form-control-feedback" aria-hidden="true" id="gateway"></span>
            </div>
            <div class="form-group validationenabled has-feedback" id="dns">
                <h5></h5>
                <input type="text" class="form-control" name="dns" id="dns" value="<?php echo $dns ?>" />
                <span class="glyphicon form-control-feedback" aria-hidden="true" id="dns"></span>
            </div>
            <div class="text-center">
                <button class="btn btn-primary" id="btn-save-settings" ></button>
            </div>

        </div>

        <script src="js/jquery-1.11.2.min.js"></script>
        <script src="js/bootstrap.min.js"></script>
        <script src="js/lms.js"></script>
</html>


